"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.groupByNodeSignatureType = exports.sortSignatureType = void 0;
const semantics_entities_semantic_schema_1 = require("@teambit/semantics.entities.semantic-schema");
const pluralize_1 = __importDefault(require("pluralize"));
function sortSignatureType([aType], [bType]) {
    if (!aType)
        return -1;
    if (!bType)
        return 1;
    if (aType < bType)
        return -1;
    if (aType > bType)
        return 1;
    return 0;
}
exports.sortSignatureType = sortSignatureType;
function groupByNodeSignatureType(nodes) {
    return nodes.reduce((accum, next) => {
        const { signature, __schema } = next;
        if (!signature)
            return accum;
        let type;
        if (__schema === semantics_entities_semantic_schema_1.ConstructorSchema.name) {
            type = (0, pluralize_1.default)('constructor');
        }
        else {
            const extractedType = signature.split(') ')[0].split('(')[1];
            type = extractedType ? (0, pluralize_1.default)(extractedType) : undefined;
        }
        const existing = accum.get(type) || [];
        accum.set(type, existing.concat(next));
        return accum;
    }, new Map());
}
exports.groupByNodeSignatureType = groupByNodeSignatureType;
//# sourceMappingURL=group-schema-node-by-signature.js.map